Package picard.analysis

## Class CollectQualityYieldMetrics

- java.lang.Object
- - picard.cmdline.CommandLineProgram
  - - picard.analysis.SinglePassSamProgram
    - - picard.analysis.CollectQualityYieldMetrics

-     @DocumentedFeature
      public class CollectQualityYieldMetrics
      extends SinglePassSamProgram

  Command line program to calibrate quality yield metrics

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `CollectQualityYieldMetrics.QualityYieldMetrics` | A set of metrics used to describe the general quality of a BAM file
    `static class` | `CollectQualityYieldMetrics.QualityYieldMetricsCollector` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `boolean` | `INCLUDE_SECONDARY_ALIGNMENTS` |
    `boolean` | `INCLUDE_SUPPLEMENTAL_ALIGNMENTS` |
    `boolean` | `USE_ORIGINAL_QUALITIES` |

    - ### Fields inherited from class picard.analysis.SinglePassSamProgram

      `ASSUME_SORTED, INPUT, OUTPUT, STOP_AFTER`

    - ### Fields inherited from class picard.cmdline.CommandLineProgram

      `COMPRESSION_LEVEL, CREATE_INDEX, CREATE_MD5_FILE, GA4GH_CLIENT_SECRETS, MAX_RECORDS_IN_RAM, QUIET, REFERENCE_SEQUENCE, referenceSequence, specialArgumentsCollection, TMP_DIR, USE_JDK_DEFLATER, USE_JDK_INFLATER, VALIDATION_STRINGENCY, VERBOSITY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CollectQualityYieldMetrics()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `acceptRead​(htsjdk.samtools.SAMRecord rec, htsjdk.samtools.reference.ReferenceSequence ref)` | Should be implemented by subclasses to accept SAMRecords one at a time.
    `protected void` | `finish()` | Should be implemented by subclasses to do one-time finalization work.
    `protected void` | `setup​(htsjdk.samtools.SAMFileHeader header, File samFile)` | Should be implemented by subclasses to do one-time initialization work.
    `protected boolean` | `usesNoRefReads()` | Ensure that we get all reads regardless of alignment status.

    - ### Methods inherited from class picard.analysis.SinglePassSamProgram

      `doWork, makeItSo, setReferenceSequence`

    - ### Methods inherited from class picard.cmdline.CommandLineProgram

      `customCommandLineValidation, getCommandLine, getCommandLineParser, getDefaultHeaders, getFaqLink, getMetricsFile, getStandardUsagePreamble, getStandardUsagePreamble, getVersion, hasWebDocumentation, instanceMain, instanceMainWithExit, makeReferenceArgumentCollection, parseArgs, requiresReference, setDefaultHeaders, useLegacyParser`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### USE_ORIGINAL_QUALITIES

          @Argument(shortName="OQ",
                    doc="If available in the OQ tag, use the original quality scores as inputs instead of the quality scores in the QUAL field.")
          public boolean USE_ORIGINAL_QUALITIES

    - #### INCLUDE_SECONDARY_ALIGNMENTS

          @Argument(doc="If true, include bases from secondary alignments in metrics. Setting to true may cause double-counting of bases if there are secondary alignments in the input file.")
          public boolean INCLUDE_SECONDARY_ALIGNMENTS

    - #### INCLUDE_SUPPLEMENTAL_ALIGNMENTS

          @Argument(doc="If true, include bases from supplemental alignments in metrics. Setting to true may cause double-counting of bases if there are supplemental alignments in the input file.")
          public boolean INCLUDE_SUPPLEMENTAL_ALIGNMENTS

  - ### Constructor Detail

    - #### CollectQualityYieldMetrics

          public CollectQualityYieldMetrics()

  - ### Method Detail

    - #### usesNoRefReads

          protected boolean usesNoRefReads()

      Ensure that we get all reads regardless of alignment status.
      Overrides:
        `usesNoRefReads` in class `SinglePassSamProgram`

    - #### setup

          protected void setup​(htsjdk.samtools.SAMFileHeader header,
                               File samFile)

      Description copied from class: `SinglePassSamProgram`
      Should be implemented by subclasses to do one-time initialization work.
      Specified by:
        `setup` in class `SinglePassSamProgram`

    - #### acceptRead

          protected void acceptRead​(htsjdk.samtools.SAMRecord rec,
                                    htsjdk.samtools.reference.ReferenceSequence ref)

      Description copied from class: `SinglePassSamProgram`
      Should be implemented by subclasses to accept SAMRecords one at a time. If the read has a reference sequence and a reference sequence file was supplied to the program it will be passed as 'ref'. Otherwise 'ref' may be null.
      Specified by:
        `acceptRead` in class `SinglePassSamProgram`

    - #### finish

          protected void finish()

      Description copied from class: `SinglePassSamProgram`
      Should be implemented by subclasses to do one-time finalization work.
      Specified by:
        `finish` in class `SinglePassSamProgram`